import http.server
import socketserver
import json
from telethon import TelegramClient
import urllib.parse
import os
import asyncio

# Your Telegram API credentials
api_id = '26728096'
api_hash = 'c6b92f27cd5e5882aeb9aa367e09d049'

# Create the Telegram client
client = TelegramClient('session_name', api_id, api_hash)

PORT = 8010

class MyHttpRequestHandler(http.server.SimpleHTTPRequestHandler):
    def do_GET(self):
        parsed_path = urllib.parse.urlparse(self.path)
        query = urllib.parse.parse_qs(parsed_path.query)

        if parsed_path.path == '/get_rooms':
            loop = asyncio.get_event_loop()  # Use the current event loop
            response = loop.run_until_complete(self.get_rooms())
            self.send_response(200)
            self.send_header('Content-type', 'application/json')
            self.end_headers()
            self.wfile.write(json.dumps(response).encode('utf-8'))

        elif parsed_path.path == '/get_messages':
            chat_id = query.get('chat_id', [None])[0]
            if chat_id:
                loop = asyncio.get_event_loop()  # Use the current event loop
                response = loop.run_until_complete(self.get_messages(int(chat_id)))
                self.send_response(200)
                self.send_header('Content-type', 'application/json')
                self.end_headers()
                self.wfile.write(json.dumps(response).encode('utf-8'))
            else:
                self.send_error(400, "chat_id is required")

        elif parsed_path.path == "/":
            self.serve_html()
        else:
            self.send_error(404, "Page not found")

    def serve_html(self):
        try:
            file_path = "index.html"
            with open(file_path, 'rb') as file:
                self.send_response(200)
                self.send_header('Content-type', 'text/html')
                self.end_headers()
                self.wfile.write(file.read())
        except IOError:
            self.send_error(404, "File not found")

    def do_POST(self):
        parsed_path = urllib.parse.urlparse(self.path)
        if parsed_path.path == '/send_message':
            content_length = int(self.headers['Content-Length'])
            post_data = self.rfile.read(content_length)
            data = json.loads(post_data)

            chat_id = data.get('chat_id')
            message = data.get('message')

            if chat_id and message:
                loop = asyncio.get_event_loop()  # Use the current event loop
                response = loop.run_until_complete(self.send_message(int(chat_id), message))
                self.send_response(200)
                self.send_header('Content-type', 'application/json')
                self.end_headers()
                self.wfile.write(json.dumps(response).encode('utf-8'))
            else:
                self.send_error(400, "chat_id and message are required")
        else:
            self.send_error(404, "Unsupported POST endpoint")

    async def get_rooms(self):
        """Fetch the list of all rooms (chats)"""
        rooms = []
        if not client.is_connected():
            await client.connect()
        async for dialog in client.iter_dialogs():
            rooms.append({'name': dialog.name, 'id': dialog.id})
        return rooms

    async def get_messages(self, chat_id):
        """Fetch messages from a selected chat, including sender usernames"""
        if not client.is_connected():
            await client.connect()

        messages = await client.get_messages(chat_id, limit=10)
        formatted_messages = []
        for msg in messages:
            sender_entity = await client.get_entity(msg.sender_id)  # Get the sender entity
            sender_name = sender_entity.username or sender_entity.first_name  # Use username or first name
            formatted_messages.append({
                'sender_name': sender_name,
                'message': msg.message,
                'date': str(msg.date)
            })
        return formatted_messages

    async def send_message(self, chat_id, message):
        """Send a message to a chat"""
        if not client.is_connected():
            await client.connect()
        await client.send_message(chat_id, message)
        return {'status': 'Message sent'}

# Set up the HTTP server
Handler = MyHttpRequestHandler

with socketserver.TCPServer(("", PORT), Handler) as httpd:
    print(f"Serving on port {PORT}")
    httpd.serve_forever()
